﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;

namespace ChangingRowBackgroundProgrammatically
{
    public partial class ChangingRowBackground : Window
    {
        private BindingList<Person> listOfPeople;
        private DataRecordPresenter oldDataRecordPresenter = new DataRecordPresenter();
        private DataRecord oldRecord = null;

        public ChangingRowBackground()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            InitializeListOfPeople();
            xamDataGrid1.DataSource = listOfPeople;
            xamDataGrid1.RecordUpdated += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs>(xamDataGrid1_RecordUpdated);
        }

        private void InitializeListOfPeople()
        {
            listOfPeople = new BindingList<Person>();
            listOfPeople.AllowEdit = true;
            listOfPeople.Add(new Person() { ID = 1, FirstName = "Yanko", LastName = "Manolov" });
            listOfPeople.Add(new Person() { ID = 2, FirstName = "Peter", LastName = "Velev" });
            listOfPeople.Add(new Person() { ID = 3, FirstName = "Petko", LastName = "Todorov" });
            listOfPeople.Add(new Person() { ID = 4, FirstName = "Hristo", LastName = "Dimitrov" });
            listOfPeople.Add(new Person() { ID = 5, FirstName = "Boris", LastName = "Hristov" });
        }

        void xamDataGrid1_RecordUpdated(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs e)
        {
            if (oldRecord != null)
            {
                DataRecordPresenter.FromRecord(oldRecord).Background = oldDataRecordPresenter.Background;
            }
            oldDataRecordPresenter.Background = DataRecordPresenter.FromRecord((Record)e.Record).Background;
            oldRecord = e.Record;
            DataRecordPresenter.FromRecord((Record)e.Record).Background = Brushes.LightGoldenrodYellow;
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;
        private string fname;
        private string lname;

        public int ID
        {
            get { return id; }
            set
            {
                id = value;
                OnPropertyChanged("ID");
            }
        }

        public string FirstName
        {
            get { return fname; }
            set
            {
                fname = value;
                OnPropertyChanged("FirstName");
            }
        }

        public string LastName
        {
            get { return lname; }
            set
            {
                lname = value;
                OnPropertyChanged("LastName");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }

        #endregion
    }
}
